var $ = jQuery;
$(function() {

// Поиск студентов
function AddStudent(ID, Name, From, GroupID, Bind){
	if (Bind == true)
		var Status = 'StatusBind';
	else 
		var Status = 'StatusUnbind';
	var r = '\
		<div id="'+ ID +'" class="Student '+ Status +' '+ GroupID +'">\
			<span class="Name">'+ Name +'</span> \
			<span class="From">'+ From +'</span>';
	if (Bind == true)
		r +='<span class="action Action_UnbindStudent">Отсоединить студента</span>';
	else
		r +='<span class="action Action_BindStudent">Прикрепить студента</span>';
	r +=
		'</div>';
	return r;
}

function AddStudentInSearchBox(ID, Name, From, GroupID, Bind){
	if (Bind == true)
		var Status = 'StatusBind';
	else 
		var Status = 'StatusUnbind';
	var r = '\
		<div id="'+ ID +'" class="Student '+ Status +' '+ GroupID +'">\
			<span class="Name">'+ Name +'</span> \
			<span class="From">'+ From +'</span>';
	if (Bind == true)
		r +='<span class="action Action_UnbindStudent">Отсоединить студента</span>';
	else
		r +='<span class="action Action_BindStudentFromSearch">Прикрепить студента</span>';
	r +=
		'</div>';
	return r;
}

// Поиск студентов
function CallSearchStudents() 
{
	var Name = [];
	if ($('.InputStudentName').val().length > 0)
		Name = ($('.InputStudentName').val()).split(' ');
	$.post(
		URLdir + 'handler/map/SearchStudents',
		{
			'GradeID': $('.SelectGrade').val(),
			'GroupN': $('.SelectStudyGroup').val(),
			'FacultyID': FacultyID,
			'Last': Name[0],
			'First': Name[1],
			'Second': Name[2],
			'DisciplineID': DisciplineID
		},
		function(data){
			var SearchResult = $.parseJSON(data);
			var jSearch = $('.SearchResult').first();
			var counter = parseInt(SearchResult.Count);
			$('.SearchResult').html('');
			if (counter <= 0)
				jSearch.html('<p class="notification">Нет результатов... Возможно, студенты, соответствующие критериям поиска, уже прикреплены.</p>');
			else 
			{
				var data = '';
				for(var i = 1; i <= counter; ++i) 
				{
					var ID = SearchResult[i].StudentID;
					var Name = SearchResult[i].StudentLast +' '+  SearchResult[i].StudentFirst +' '+ SearchResult[i].StudentSecond;
					var From = 'Курс ' + SearchResult[i].GroupGrade + ', Группа ' + SearchResult[i].GroupNum;
					var GroupID = 'GroupID_'+SearchResult[i].GroupID;
					data += AddStudentInSearchBox(ID, Name, From, GroupID, false);
				}
				jSearch.html($.parseHTML(data));
			}
		}
	);	
}

$('.SelectGrade').change(function(){
	$.post(
		URLdir + 'handler/map/GetStudyGroups',
		{
			'FacultyID': FacultyID,
			'GradeID': $(this).val()
		},
		function(data){
			data = $.parseJSON(data);
			if (data != null && data != undefined) {
				$('.SelectStudyGroup').html('<option value="0">Выберите группу:</option>');
				for (i = 1; i <= data.count; i++) {
					$('.SelectStudyGroup').append('<option value="'+ data[i].GroupID +'">Группа '+ data[i].GroupNum +' - '+ data[i].SpecName +'</option>');
				}
				
				if (data.count <= 0)
					$('.SelectStudyGroup').append('<option value="0">Нет групп</option>');		
			}
			CallSearchStudents();
		}
	);
});
$('.SelectStudyGroup').change(function(){
	CallSearchStudents();
});
$('.InputStudentName').focusout(function(){
	CallSearchStudents();
});
$('.InputStudentName').keydown(function(e){
	if(e.keyCode==13){
		$(this).focusout('focusout');
		$(this).blur();
	}
});

$('.SelectGrade').focusout(function(){
	$(this).trigger('change');
});


$('.SelectStudyGroup').focusout(function(){
	$(this).trigger('change');
});

// Если студент из поиска
function BindStudentFromSearch(thisObj) 
{
	var reg = /GroupID_\d+/;
	var GroupID = ''+reg.exec(thisObj.parent().attr('class'));
	var ID = thisObj.parent().attr('id');
	var Name = thisObj.siblings('.Name').text();
	var From = thisObj.siblings('.From').text();
	if ($('div').is('.GroupContainer.'+GroupID) === false) {
		$('.AttachedStudentsList').append('\
			<div class="GradeAndGroupTitle ActionShowHideGroupContainer">\
			<span class="info">'+From+'</span>\
			<span class="Action">Открыть список ▼</span>\
		</div>');
		$('.AttachedStudentsList').append('<div class="GroupContainer '+GroupID+'" style="display: block"> </div>');
	}
	$('.GroupContainer.'+GroupID).append(AddStudent(ID, Name, From, GroupID, true));
	thisObj.parent().remove();
}

// Если студент из основного потока
function BindBackStudent(thisObj) {
	thisObj
		.removeClass('Action_BindStudent')
		.addClass('Action_UnbindStudent')
		.text('Отсоединить студента');
	thisObj
		.parent()
		.removeClass('StatusUnbind')
		.addClass('StatusBind');
}

// Прикрепить студента 
$('.StudentsList').on('click', '.Action_BindStudent', function(){
	var thisObj = $(this);
	var ID = $(this).parent().attr('id');
	$.post(
		URLdir + 'handler/map/BindStudent',
		{
			'StudentID': ID,
			'DisciplineID': DisciplineID
		},
		function(data){
			data = $.parseJSON(data);
			if(data.success === true) {
				BindBackStudent(thisObj);
				EventInspector_ShowMsg('Студент добавлен', 'success');
			}
			else EventInspector_ShowMsg('Ошибка при добавление студента', 'error');
		}
	);
});

// Прикрепить студента из поиска
$('.StudentsList').on('click', '.Action_BindStudentFromSearch', function(){
	var thisObj = $(this);
	var ID = $(this).parent().attr('id');
	$.post(
		URLdir + 'handler/map/BindStudent',
		{
			'StudentID': ID,
			'DisciplineID': DisciplineID
		},
		function(data){
			data = $.parseJSON(data);
			if(data.success === true) {
				BindStudentFromSearch(thisObj);
				EventInspector_ShowMsg('Студент добавлен', 'success');
			}
			else EventInspector_ShowMsg('Ошибка при добавление студента', 'error');
		}
	);
});

// Отсоединить студента 
$('.StudentsList').on('click', '.Action_UnbindStudent', function(){
	$(this)
		.removeClass('Action_UnbindStudent')
		.addClass('Action_BindStudent')
		.text('Прикрепить студента');
	$(this)
		.parent()
		.removeClass('StatusBind')
		.addClass('StatusUnbind');
	var ID = $(this).parent().attr('id');
	$.post(
		URLdir + 'handler/map/UnbindStudent',
		{
			'StudentID': ID,
			'DisciplineID': DisciplineID
		},
		function(data){
			data = $.parseJSON(data);
			if(data.success === true)
				EventInspector_ShowMsg('Студент отсоединен', 'success');
			else EventInspector_ShowMsg('Ошибка при отсоединение студента', 'error');
		}
	);
});

$('.StudentsList').on('click', '.ActionShowHideGroupContainer', function(){
	if ($(this).next('.GroupContainer').css('display') == 'none') {
		$(this).children('.Action').text('Скрыть список ▲');
		$(this).next('.GroupContainer').show();
	}
	else {
		$(this).children('.Action').text('Открыть список ▼');
		$(this).next('.GroupContainer').hide();
	}
});

});